#ifndef PARTICLESYSTEM

#define PARTICLESYSTEM


#include "SM_Engine3DPCH.h"
#include "SM_Renderable.h"

struct Particle
{
  Vector3D v3dStart;
  Vector3D v3dVelocity;
  float    fBirth;
  float    fDeath;
};

class RenderParticleSystem : public IRenderable
{
public:
    RenderParticleSystem    ();
    ~RenderParticleSystem   ();

    int     Init            ();
    int     Shutdown        ();

    void    Render          (RenderContext* pRenderContext, unsigned uOutcode);

    MBStaticList<Particle> ParticleList;
    int                    m_iShader;
    Vector3D               m_v3dSource;

};



#endif 